namespace ConsoleApp4
{
    internal class Program
    {
        public static void UnosPodataka(out long n, out int k, out int[] d)
        {
            long[] input = Array.ConvertAll(Console.ReadLine().Split(' '), long.Parse);
            n = input[0];
            k = (int)input[1];

            d = Array.ConvertAll(Console.ReadLine().Split(' '), int.Parse);
        }

        public static void DeliociBroja(int[] d, int k)
        {
            for (int i = 0; i < k; i++)
            {
                int xorDelioca = 1;
                for (int j = 2; j < d[i] / 2; j++)
                {
                    if (d[i] % j == 0) xorDelioca = xorDelioca ^ j;
                }
                Console.Write(xorDelioca + " ");
            }
        }

        static void Main(string[] args)
        {
            UnosPodataka(out long n, out int k, out int[] d);

            DeliociBroja(d, k);
        }
    }
}